SyntaxElementMorph subclass: #ArgumentElementMorph
	instanceVariableNames: 'contents oldColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 13:40'!
acceptDroppingMorph: aMorph event: evt

	self contentsForced: aMorph! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/5/2009 00:50'!
asSmalltalk

	contents ifNil: [^'nil '].
	((#(	BlockElementMorph
		LiteralElementMorph
		ObjectElementMorph
	) includes: contents class printString asSymbol)
		or: [owner isKindOf: StepElementMorph])
		ifTrue: [^contents asSmalltalk].

	(contents isKindOf: MessageElementMorph) ifTrue: [
		contents isUnary ifTrue: [^contents asSmalltalk].

		contents isBinary ifTrue: [
			owner isKeywords ifTrue: [ ^contents asSmalltalk]]

	].

	^'(', contents asSmalltalk, ')'! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 13:38'!
contents
	^contents! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:51'!
contents: anElement
	contents ifNotNil: [contents delete].
	anElement representsNil ifFalse: [
		contents _ anElement.
		self addMorphFront: contents ].
	self fit.
	self unHilite
! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 21:09'!
contentsForced: anElement
	contents ifNotNil: [contents delete].
	contents _ anElement.
	contents position: self position.
	self addMorphFront: contents.
	self fit.
	self unHilite
! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 21:13'!
drawOn: aCanvas 

	|r bw|

	bw _ self borderWidth.

	"border"
	"top"
	r _ Rectangle origin: ((self left + bw) @ self top) corner: (self right @ (self top + bw)).
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	"left"
	r _ Rectangle origin: (self topLeft) corner: (self left + bw) @ (self bottom - bw).
	aCanvas fillRectangle: r color: self borderColorDark.

	"right"
	r _ Rectangle origin: ((self right - bw) @ (self top + bw)) corner: self bottomRight.
	aCanvas fillRectangle: r color: self borderColorLight.

	"bottom"
	r _ Rectangle origin: (self left @ (self bottom - bw)) corner: (self right - bw) @ self bottom.
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	"body"
	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self bottomRight - bw)) color: color
! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 22:49'!
fit
	| h |
	contents isNil
		ifTrue: [
			h _ MessageElementMorph labelFont height.
			self extent: h @ h]
		ifFalse: [
			self extent: contents extent " + (self borderWidth * 2)".
			"(owner isKindOf: StepElementMorph)
				ifTrue: [self extent: self extent + (self borderWidth * 2)]."
			contents position: bounds center - (contents extent // 2) ].
	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:06'!
handlesMouseOverDragging: evt
	"Return true if I want to receive mouseEnterDragging: and mouseLeaveDragging: when the hand drags something over me (button up or button down), or when the mouse button is down but there is no mouseDown recipient. The default response is false; subclasses that implement mouse mouseEnterDragging messages should override this to return true."

	"NOTE:  If the hand state matters in these cases, it may be tested by constructs such as
		event anyButtonPressed
		event hand hasSubmorphs"

	^ true
! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:46'!
hilite
	oldColor _ color.
	self color: Color white! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:47'!
initialize
	super initialize.
	color _ Color veryVeryLightGray.
	self fit! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 01:00'!
mouseEnterDragging: evt
	"Handle a mouseEnterDragging event. The mouse just entered my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	| m |
	evt hand hasSubmorphs ifFalse: [^self].
	m _ evt hand submorphs first.
	(self wantsDroppedMorph: m event: evt)
		ifTrue: [
			self extent: m extent  + (self borderWidth * 2).
			self hilite ].
	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:48'!
mouseLeaveDragging: evt
	"Handle a mouseLeaveLaden event. The mouse just left my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	self fit.
	self unHilite! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2009 20:53'!
removeContents
	contents ifNotNil: [ contents _ nil ].
	self fit.
! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:37'!
rootForGrabOf: aMorph
	"Answer the root of the morph structure to be picked up when the given morph is grabbed."

	owner ifNotNil: [^owner rootForGrabOf: aMorph].
	^nil

"	(self isSticky and: [self isPartsDonor not])
		ifTrue: [^ nil]
		ifFalse: [
			(owner isNil or: [owner isWorldOrHandMorph])
				ifTrue: [^ self]
				ifFalse: [
					owner allowSubmorphExtraction
						ifTrue: [^ self]
						ifFalse: [^ owner rootForGrabOf: aMorph]]].
"! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:47'!
unHilite

	oldColor ifNotNil: [
		self color: oldColor]! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:51'!
wantsDroppedMorph: aMorph event: evt

	^contents isNil 
		& (self ownerThatIsA: ElementPaletteMorph) isNil
		& ((aMorph isKindOf: ObjectElementMorph) 
		| (aMorph isKindOf: LiteralElementMorph) 
		| (aMorph isKindOf: BlockElementMorph) 
		| (aMorph isKindOf: MessageElementMorph))! !
