NXTSensor subclass: #NXTButtons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting-NXT Peripherals'!
!NXTButtons commentStamp: '<historical>' prior: 0!
NXTButtons represents the buttons just below the NXT screen.  Note that there is always one, and only one, set of NXT buttons in use; the peripheral is never configured by the end user.!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NXTButtons class
	instanceVariableNames: ''!

!NXTButtons class methodsFor: 'block specs' stamp: 'CWB 7/5/2011 21:42'!
configBlockSpec
"The buttons are not user configurable.  Every NXT has them, at all times."

	^ nil.! !

!NXTButtons class methodsFor: 'block specs' stamp: 'CWB 1/3/2011 09:58'!
obsoleteBlocks
"Returns a list of blocks that used to be provided by this block but have been deprecated and should not be used in the future.  These blocks will still load from files, but can not be freshly created in new programs, and need not be translated"

	| blocks |
	
	blocks _ #(
		'sensing'
			('any button pressed?'				b	isAnyNxtButtonPressed)	"left old selector intact"
		).

	^ blocks  ! !

!NXTButtons class methodsFor: 'block specs' stamp: 'CWB 11/22/2011 09:50'!
providesBlocks
"Returns a list of block specifications to be used in the main user interface if there is any device configured that can use these blocks.  Note that the 'selectors' are all unique, start with the class name followed by a colon, but do not actually have functions that go with them."

	| blocks |
	
	blocks _ #(
		'sensing'
			('%J button is pressed?' 				b	NXTButtons:pressed:)
		'control'
			('wait until %J button is pressed and released'	-	NXTButtons:waitForPress:)
		).

	^ blocks  ! !


!NXTButtons class methodsFor: 'dropdown lists' stamp: 'CWB 1/3/2011 09:26'!
customListNumber: aNumber
"Peripherals can return custom lists (or nil)."

	(aNumber = 1) ifTrue: [
		"Names of the buttons"
		^ #('enter' 'left arrow' 'right arrow' 'exit')
	].
	(aNumber = 2) ifTrue: [
		"State of the button"
		^ #('pressed' 'released' 'pressed then released' 'released then pressed')	
	].

	^ nil.! !


!NXTButtons class methodsFor: 'accessing' stamp: 'CWB 7/1/2011 17:12'!
concreteTypes
"Returns a list of physical devices that implement the functions of this class."

	^ #().! !
